(load "defaultlisplib.lsp")
(load "ph3dlib.lsp")
(load "PhBody.lsp")

(SetLispConsoleMenu "Edit" "Stop Simulation"
	'(lambda () 	
		(SetXPhSimulationFlag nil)
	)
)

(SetLispConsoleMenu "Edit" "Start Simulation"
	'(lambda () 
		(SetXPhSimulationFlag t)
	)
)

(def _x_object_Menu nil)

(SetLispConsoleMenu "Edit" "Load *.x object"
	'(lambda () 
		(let
			(
				(fname (OpenFileDialog "objects" "*.x"))
			)
			(if fname
				(progn
					(def _x_object_Menu
						(cons (LoadXPhBody fname) _x_object_Menu)
					)
					
				)
				nil
			)
		)
	)
)

(SetLispConsoleMenu "Edit" "Load RotationalCamera"
	'(lambda () 	
		(load "RotationalCamera.lsp")
	)
)

'(SetLispConsoleMenu "test" "test"
	nil
)

(SetLispConsoleMenu "Edit" "Load MousePicker"
	'(lambda () 	
		(load "MousePicker.lsp")
	)
)

