;Cu̓ǂݍ
(Load "defaultlisplib.lsp")
(Load "ph3dlib.lsp")

;΂ˌWȂǂ̃p[^̏
(PhDefaultParamSetUp)
'(SetCollisionSpringCoeff 20.0)

;߂荞݋eʂ̐ݒ
(SetInterferencePermitDistance 0.05)

;Î~CW̐ݒ
(SetCollisionStaticFrictionCoeff 0.8)

;CW̐ݒ
(SetCollisionDynamicFrictionCoeff 0.7)

;˕ԂW
(SetCollisionReboundCoeff 0.3)

;̌`t@C̓ǂݍ
(def floor (LoadXPhBody "gfloor.x"))
(PhSetUpForFixedObject floor)
(SetXPhBodyMat floor '((1 0 0) (0 1 0) (0 0 1) (0 -5 0)))
(SetXPhVertexTransformMat floor '((5 0 0) (0 5 0) (0 0 5) (0 0 0)))
(XPhBodySetVisualMaterial floor '((1 1 1 1) (0.5 0.5 0.5 0.5) (0 0 0 0) 0))

(defun makeblockes (num pos)
	
	(if (> num 0)
		(let
			(
				(block (LoadXPhBody "kuubox3.x"))
			)

			(SetXPhBodyMat block (list '(1 0 0) '(0 1 0) '(0 0 1) pos))

			(cons block (makeblockes (- num 1) (VAdd pos '(2.0 0 0))) )
		)
		nil
	)

)

(defun makehill (num pos)
	(if (> num 0)
		(cons (makeblockes num pos) (makehill (- num 1) (VAdd pos '(1.0 2.0 0))) )
		nil
	)
)

(def box (makehill 5 '(-5 0 0)))


(load "RotationalCamera.lsp")	;J[\L[E,XL[őłJ̐ݒ
				;camera_managerɃJ̕ϐ
(XPhBodySetData camera_manager (list (* (PI) -0.5) 0 0 0 0))

(def xoss nil)

(defun MouseDownFunc (mode sx sy dx dy dz px py pz)
	(def xoss (XPhRayPick (list dx dy dz) (list px py pz)))
	(if (select xoss 0)
		(let
			(
				(Mat (GetXPhBodyMat (select xoss 0)))
			)
			(def xva (InvTranslate (select xoss 1) Mat))
			(def d_old (list dx dy dz))
			(def p_old (list px py pz))
		)
	)
)

(SetMouseDownProc MouseDownFunc)

(defun MouseMoveFunc (mode sx sy dx dy dz px py pz)
	(def d_old (list dx dy dz))
	(def p_old (list px py pz))
	(def test 32)
)

(SetMouseMoveProc MouseMoveFunc)

(defun MouseUpFunc (mode sx sy dx dy dz px py pz)
	(def xoss nil)
)

(SetMouseUpProc MouseUpFunc)

(defun mfunc(this)
	(if xoss
		(let
			(
				(Mat (GetXPhBodyMat (select xoss 0)))
				(ta (select xoss 2))
				(d (VSub (VAdd (VMul d_old ta) p_old) (Translate xva Mat) ))
			)
			(def da d)
			(XPhBodyAddLinearForce (select xoss 0) (VMul d 30))
		)

	)
)

(def mouse_manager (MakeEmptyXPhBody))

(XPhBodySetFunction mouse_manager
		mfunc
)

