;Cu̓ǂݍ
(Load "defaultlisplib.lsp")
(Load "ph3dlib.lsp")

(XPhSet_EasyViewText 
	(strcat
		"J[\L[ňړ\n"
		"]񂾂X\n"
	)
)

(XPhFogEnable t)
(XPhBgColor 230 230 233)

;΂ˌWȂǂ̃p[^̏
(PhDefaultParamSetUp)
'(SetCollisionSpringCoeff 520.0)
'(SetCollisionVerticalDamperCoeff 1.0)
'(SetCollisionHorizontalDamperCoeff 2.0f)

;Î~CW̐ݒ
(SetCollisionStaticFrictionCoeff 1.8)

;CW̐ݒ
(SetCollisionDynamicFrictionCoeff 1.5)

;AXt@g - S
;Î~CW̐ݒ
;(SetCollisionStaticFrictionCoeff 0.8)

;CW̐ݒ
;(SetCollisionDynamicFrictionCoeff 0.55)

;̌`t@C̓ǂݍ
(def floor (LoadXPhBody "pala.x"))
'(def floor (LoadXPhBody "gfloor.x"))
(PhSetUpForFixedObject floor)
(SetXPhBodyMat floor '((1 0 0) (0 1 0) (0 0 1) (0 -5 0)))
(SetXPhVertexTransformMat floor '((7 0 0) (0 7 0) (0 0 7) (0 0 0)))
'(XPhBodySetVisualMaterial floor '((1 1 1 1) (0.5 0.5 0.5 0.5) (0 0 0 0) 0))

;x^̕
(def xobj (LoadXPhBody "xbox.x"))
(SetXPhBodyMat xobj '((1 0 0) (0 1 0) (0 0 1) (0 5 10)))

(def ball (LoadXPhBody "mbox.x"))
(SetXPhBodyMat ball '((1 0 0) (0 1 0) (0 0 1) (0 10 10)))


;I^{bgǂݍ
(Load "LispAutoMobile.lsp")

(def AutoMobile (MakeAutoMobile))

(let
	(
		(data (XPhBodyGetData AutoMobile))
	)

	(def data (assoc_list_set data 'view_point '(0.0 0.0 -10.0)))

	(XPhBodySetData AutoMobile data)
)

(defun AutoMobileFunc (this)
	(let
		(
			(data (XPhBodyGetData this))
			(jointlist (assoc_list_search data 'joints))
			(view (assoc_list_search data 'view_point))
			(tMat (GetXPhBodyMat this))
			(axel 55.0)
			(j0ax 0.0) (j1ax 0.0) (j2ax 0.0) (j3ax 0.0)
		)

		

		(if (XPhBodyGetKeyState this 38)	;L[ꂽꍇ
			((lambda ()
				(def j0ax (+ j0ax axel))
				(def j1ax (+ j1ax axel))
				(def j2ax (+ j2ax axel))
				(def j3ax (+ j3ax axel))

				;gN̑ł
				(XPhBodyAddAngularForce this
					(VMul (select tMat 0) (* axel 4)))
			))
			nil
		)

		(if (XPhBodyGetKeyState this 40)	;L[ꂽꍇ
			((lambda ()
				(def j0ax (+ j0ax (- 0 axel)))
				(def j1ax (+ j1ax (- 0 axel)))
				(def j2ax (+ j2ax (- 0 axel)))
				(def j3ax (+ j3ax (- 0 axel)))

				;gN̑ł
				(XPhBodyAddAngularForce this
					(VMul (select tMat 0) (* axel -4)))
			))
			nil
		)


		(if (XPhBodyGetKeyState this 37)	;L[ꂽꍇ
			((lambda ()
				(def j0ax (+ j0ax (- 0 axel)))
				(def j1ax (+ j1ax (- 0 axel)))
				(def j2ax (+ j2ax axel))
				(def j3ax (+ j3ax axel))
			))
			nil
		)

		(if (XPhBodyGetKeyState this 39)	;L[ꂽꍇ
			((lambda ()
				(def j0ax (+ j0ax axel))
				(def j1ax (+ j1ax axel))
				(def j2ax (+ j2ax (- 0 axel)))
				(def j3ax (+ j3ax (- 0 axel)))
				
			))
			nil
		)

		(if (XPhBodyGetKeyState this 88)	;xL[ꂽꍇ
			((lambda ()
				(XPhBodyAddForce this
						'(0 1 0)
						(VAdd 
							(select tMat 3)
							(VMul (select tMat 1) 10.0)
						)
				)	;pۂ߂ɏdS荂ʒuɕオ͂
				(XPhBodyAddLinearForce this '(0 400 0))	;㏸
			))
			nil
		)


		((lambda ()
			(XPhJointSetTorque (select jointlist 0) j0ax)
			(XPhJointSetTorque (select jointlist 1) j1ax)
			(XPhJointSetTorque (select jointlist 2) j2ax)
			(XPhJointSetTorque (select jointlist 3) j3ax)
		))

		(let
			(
				(tMat (GetXPhBodyMat this))	
					;̊֐蓖ĂĂ镨̂̈ʒu擾
				(va '(0 0 0))
			)
			(def va (VAdd va '(0 2 0)))
			(def va (VAdd va (VAdd (select tMat 3) (VMul (select tMat 2) -6))))
			(def view (VAdd (VMul va 0.1)  (VMul view 0.9)))
			(def tMat (GetXPhBodyMat this))
			(def tMat (list (select tMat 0) (select tMat 1)
					 (select tMat 2) 
					view)
			)
			(SetXPhCameraMat tMat)	;J̈ʒuݒ

			(def data (assoc_list_set data 'view_point view))
			(XPhBodySetData AutoMobile data)
		)
	)
)

(XPhBodySetFunction AutoMobile AutoMobileFunc)



(def camera_manager (MakeEmptyXPhBody))

(defun func (this)
	(let
		(
			(data (XPhBodyGetData this))
			(theta (car data))
			(phi (car (cdr data)))
			(x (select data 2))
			(y (select data 3))
			(va '(0 0 0))
		)

		(if (XPhBodyGetKeyState this 37)	;L[ꂽꍇ
			(def theta (+ theta 0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 39)	;L[ꂽꍇ
			(def theta (+ theta -0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 38)	;L[ꂽꍇ
			(def phi (+ phi 0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 40)	;L[ꂽꍇ
			(def phi (+ phi -0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 69)	;EL[ꂽꍇ
			((lambda ()
				(def x (- x (* (* (cos theta) (cos phi)) 0.1)))
				(def y (- y (* (* (sin theta) (cos phi)) 0.1)))
			))
			nil
		)

		(if (XPhBodyGetKeyState this 88)	;XL[ꂽꍇ
			((lambda ()
				(def x (+ x (* (* (cos theta) (cos phi)) 0.1)))
				(def y (+ y (* (* (sin theta) (cos phi)) 0.1)))
			))
			nil
		)

		'(if (XPhBodyGetKeyState this 88)	;XL[ꂽꍇ
			((lambda ()
				(def x (+ x (* (* (sin theta) (cos phi)) 0.1)))
				(def y (- y (* (* (cos theta) (cos phi)) 0.1)))
			))
			nil
		)

		(def va (list 
				(* (cos theta) (cos phi))
				(sin phi)
				(* (sin theta) (cos phi))
			)
		)

		(def va (VMul va 10))
		(def va (list (+ (select va 0) x) (select va 1) (+ (select va 2) y)))

		(SetXPhCameraMat (LookAtMat (list x 0 y) va '(0 1 0)))

		(XPhBodySetData this (list theta phi x y))

	)

)

(XPhBodySetData camera_manager '(0 0 0 0))

'(XPhBodySetFunction camera_manager
		func
)


(XPhBodyGetFuncResult camera_manager)
(XPhBodyGetFuncResult AutoMobile)

