;Cu̓ǂݍ
(Load "defaultlisplib.lsp")
(Load "ph3dlib.lsp")

;΂ˌWȂǂ̃p[^̏
(PhDefaultParamSetUp)
'(SetCollisionSpringCoeff 20.0)

;߂荞݋eʂ̐ݒ
(SetInterferencePermitDistance 0.05)

;Î~CW̐ݒ
(SetCollisionStaticFrictionCoeff 0.8)

;CW̐ݒ
(SetCollisionDynamicFrictionCoeff 0.7)

;˕ԂW
(SetCollisionReboundCoeff 0.0)

;̌`t@C̓ǂݍ
(def x (LoadXPhBody "gfloor.x"))
(PhSetUpForFixedObject x)
(SetXPhBodyMat x '((1 0 0) (0 1 0) (0 0 1) (0 -5 0)))
(SetXPhVertexTransformMat x '((5 0 0) (0 5 0) (0 0 5) (0 0 0)))
(XPhBodySetVisualMaterial x '((1 1 1 1) (0.5 0.5 0.5 0.5) (0 0 0 0) 0))

(def koma (LoadXPhBody "koma2.x"))
(XPhBodySetSameCGroupEachChild koma)

(defun komafunc (this)
	(XPhBodyAddAngularForce this
		(VMul (select (GetXPhBodyMat this) 1) 40.0)
	)

)

'(XPhBodySetFunction koma komafunc)

(XPhBodySetAVelocity koma '(0 100 0))
(XPhBodySetEAirRegistance koma 0.001)

(def box (LoadXPhBody "lbox.x"))
(SetXPhBodyMat box '((1 0 0) (0 1 0) (0 0 1) (0 5 0.25)))

(def koma2 (LoadXPhBody "koma2.x"))
(XPhBodySetSameCGroupEachChild koma2)
(SetXPhBodyMat koma2 '((1 0 0) (0 1 0) (0 0 1) (0 10 0)))
(XPhBodySetAVelocity koma2 '(0 100 0))
(XPhBodySetEAirRegistance koma2 0.001)

'(def monster (LoadXPhBody "monster.x"))
'(XPhBodySetSameCGroupEachChild monster)
'(SetXPhBodyMat monster '((1 0 0) (0 1 0) (0 0 1) (0 15 0)))

(def camera_manager (MakeEmptyXPhBody))

(defun func (this)
	(let
		(
			(data (XPhBodyGetData this))
			(theta (car data))
			(phi (car (cdr data)))
			(x (select data 2))
			(y (select data 3))
			(va '(0 0 0))
		)

		(if (XPhBodyGetKeyState this 37)	;L[ꂽꍇ
			(def theta (+ theta 0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 39)	;L[ꂽꍇ
			(def theta (+ theta -0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 38)	;L[ꂽꍇ
			(def phi (+ phi 0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 40)	;L[ꂽꍇ
			(def phi (+ phi -0.05))
			nil
		)

		(if (XPhBodyGetKeyState this 69)	;EL[ꂽꍇ
			((lambda ()
				(def x (- x (* (* (cos theta) (cos phi)) 0.1)))
				(def y (- y (* (* (sin theta) (cos phi)) 0.1)))
			))
			nil
		)

		(if (XPhBodyGetKeyState this 88)	;XL[ꂽꍇ
			((lambda ()
				(def x (+ x (* (* (cos theta) (cos phi)) 0.1)))
				(def y (+ y (* (* (sin theta) (cos phi)) 0.1)))
			))
			nil
		)

		'(if (XPhBodyGetKeyState this 88)	;XL[ꂽꍇ
			((lambda ()
				(def x (+ x (* (* (sin theta) (cos phi)) 0.1)))
				(def y (- y (* (* (cos theta) (cos phi)) 0.1)))
			))
			nil
		)

		(def va (list 
				(* (cos theta) (cos phi))
				(sin phi)
				(* (sin theta) (cos phi))
			)
		)

		(def va (VMul va 10))
		(def va (list (+ (select va 0) x) (select va 1) (+ (select va 2) y)))

		(SetXPhCameraMat (LookAtMat (list x 0 y) va '(0 1 0)))

		(XPhBodySetData this (list theta phi x y))

	)

)

(XPhBodySetData camera_manager '(0 0 0 0))

(XPhBodySetFunction camera_manager
		func
)


(XPhBodyGetFuncResult camera_manager)

