;Cu̓ǂݍ
(Load "defaultlisplib.lsp")
(Load "ph3dlib.lsp")



(def _MousePicker_Position nil)

(defun MouseDownFunc (mode sx sy dx dy dz px py pz)
	(def _MousePicker_Position (XPhRayPick (list dx dy dz) (list px py pz)))
	(if (select _MousePicker_Position 0)
		(let
			(
				(Mat (GetXPhBodyMat (select _MousePicker_Position 0)))
			)
			(def xva (InvTranslate (select _MousePicker_Position 1) Mat))
			(def d_old (list dx dy dz))
			(def p_old (list px py pz))
		)
	)
)

(SetMouseDownProc MouseDownFunc)

(defun MouseMoveFunc (mode sx sy dx dy dz px py pz)
	(def d_old (list dx dy dz))
	(def p_old (list px py pz))
	(def test 32)
)

(SetMouseMoveProc MouseMoveFunc)

(defun MouseUpFunc (mode sx sy dx dy dz px py pz)
	(def _MousePicker_Position nil)
)

(SetMouseUpProc MouseUpFunc)

(defun mfunc(this)
	(if _MousePicker_Position
		(let
			(
				(Mat (GetXPhBodyMat (select _MousePicker_Position 0)))
				(ta (select _MousePicker_Position 2))
				(d (VSub (VAdd (VMul d_old ta) p_old) (Translate xva Mat) ))
			)
			(def da d)
			(XPhBodyAddLinearForce (select _MousePicker_Position 0) (VMul d 30))
		)

	)
)

(def mouse_manager (MakeEmptyXPhBody))

(XPhBodySetFunction mouse_manager
		mfunc
)

